<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Handler_Rating extends Controller {

	protected $AcModel, $post;

        public function before() {
            parent::before();
            $this->AcModel = new Model_Account;
            $account = Auth::getData();
            $this->post = Validation::factory(Arr::map('trim', $_POST));
            if(!$this->request->is_ajax() || !Auth::isLoggedIn() || $account['Type'] != 'teacher')
                throw HTTP_Exception::factory (403, 'no access');            
        }

        public function action_setRate()
        {
            $user = Auth::getData();
            $this->post -> rule('student', 'not_empty')
                        -> rule('student', 'digit')
                        -> rule('submodule', 'not_empty')
                        -> rule('submodule', 'digit')
                        -> rule('rate', 'digit')
                        -> rule('rate', 'range', array(':value', 0, 100));
            if($this->post->check()) {
                $AccInfo = $this->AcModel->getPersonalInfoByID($user['ID'])->offsetGet(0);
                $TModel = new Model_Teacher_Rating;
                $TModel->setRate($AccInfo['TeacherID'], $this->post->offsetGet('student'), $this->post->offsetGet('submodule'), $this->post->offsetGet('rate'));
                $this->response->body(json_encode('Ok, setRate!'));
            }
            else
                $this->response->body(json_encode('Error, setRate'));
        }

        public function action_changeRate()
        {
                $user = Auth::getData();
                $this->post -> rule('student', 'not_empty')
                            -> rule('student', 'digit')
                            -> rule('submodule', 'not_empty')
                            -> rule('submodule', 'digit')
                            -> rule('rate', 'digit')
                            -> rule('rate', 'range', array(':value', 0, 100));
                if($this->post->check()) {
                    $AccInfo = $this->AcModel->getPersonalInfoByID($user['ID'])->offsetGet(0);
                    $TModel = new Model_Teacher_Rating;
                    $TModel->changeRate($AccInfo['TeacherID'], $this->post->offsetGet('student'), $this->post->offsetGet('submodule'), $this->post->offsetGet('rate'));
                    $this->response->body(json_encode('Ok, changeRate!'));
                }
                else
                    $this->response->body(json_encode('Error, changeRate'));
        }

}